// at the end of the file you'll find the Easy Language code


#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red



extern int  Lenght = 20;
int      smooth[];
int         count=0;
int      lookback=0;
double      sumcoef=0;
double      num=0;
int coef[];
int distance2[];


//---- buffers
double ExtMapBuffer[];
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int    draw_begin;
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexShift(0,0);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   draw_begin=Lenght-1;

   IndicatorShortName("Ehlers");
   SetIndexDrawBegin(0,draw_begin);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   if(Bars<=Lenght) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
//----
   Ehlers();
   return(0);
  }

void Ehlers()
  {   
 int    pos=Bars-ExtCountedBars-1;
 while(pos>=0)
     {
 
   smooth[pos]=(Close[pos] + 2*Close[pos+1] + 2*Close[pos+2] + Close[pos+3]) / 6;
//---- initial accumulation ???
   for(count=0;count<Lenght;count++)
    {distance2[count]=0;
     for(lookback=1;lookback<Lenght;lookback++)
      {distance2[count] = distance2[count] + (smooth[count] - smooth[count + lookback])*(smooth[count]- smooth[count + lookback]);
      }
     coef[count] = distance2[count];
    }

for(count=0;count<Lenght;count++)
{
   num = num + coef[count]*smooth[count];
   sumcoef = sumcoef + coef[count];
}
if (sumcoef != 0)  ExtMapBuffer[pos] = num / sumcoef;
pos--;
}
}
//+------------------------------------------------------------------+
/* Below is the EasyLanguage code:

Inputs:	Price((H+L)/2), Length(20);

Vars:	Smooth(0), count(0), LookBack(0), SumCoef(0), Num(0), Filt(0);

Array:	Coef[50](0), Distance2[50](0);

Smooth = (Price + 2*Price[1] + 2*Price[2] + Price[3]) / 6;
For count = 0 to Length -1 begin
   Distance2[count] = 0;
   For Lookback = 1 to Length-1 begin
      Distance2[count] = Distance2[count] + (Smooth[count] - Smooth[count + Lookback])*(Smooth[count] 
	- Smooth[count + Lookback]);
   End;
   Coef[count] = Distance2[count];
End;
Num = 0;
SumCoef = 0;
For count = 0 to Length -1 begin
   Num = Num + Coef[count]*Smooth[count];
   SumCoef = Sumcoef + Coef[count];
End;
If SumCoef <> 0 then Filt = Num / SumCoef;

Plot1(Filt, "Ehlers");
*/